package com.saga.util;

import java.io.File;
import java.sql.Connection;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;
import org.zillion.util.log.LogUtil;
import com.saga.entity.Data;
import com.saga.entity.PointSet;
import com.saga.entity.Record;
import com.saga.entity.Server;
import com.zillion.database.agent.ZillionAgent;

public class Constant {
	public static int PacketId = 0;
	public static int InsertThread = 1;
	public static ZillionAgent agent;
	public static Connection conn;
	// public static List<ZillionAgent> agents = new ArrayList<ZillionAgent>();
	public static boolean DBConn = true;
	public static String WaitingTimeControl = "5Second";
	public static long Disconnect = Constant.Millisecond.MINUTE_15;
	public static Map<String, Object> DbConnection = new HashMap<String, Object>();
	public static File setlog = new File(System.getProperty("user.dir") + "/setlog.log");
	public static List<String> CollectReportList = new ArrayList<String>();

	public static List<Record> RecordListToDB = new ArrayList<Record>();
	public static Map<String, String> Meter_Collector = new HashMap<String, String>();
	public static Map<String, String> Meter_Collector_Control = new HashMap<String, String>();
	public static List<PointSet> pointSetList = new ArrayList<PointSet>();
	// public static Map<String, String> CollectorPointSetList = new
	// HashMap<String, String>();
	// public static Map<String, String> BuildingDB = new HashMap<String,
	// String>();
	public static Map<String, Boolean> BuildingOffset = new HashMap<String, Boolean>();
	public static String Database;
	public static List<String> uploadList = new ArrayList<String>();
	public static Map<String, String> BuildingConv = new HashMap<String, String>();
	public static Map<String, List<String>> BuildingAdds = new HashMap<String, List<String>>();
	public static Map<String, String> FunctionConv = new HashMap<String, String>();
	public static Map<String, String> FunctionConvReverse = new HashMap<String, String>();
	// public static Map<String, String> TypePort = new HashMap<String,
	// String>();
	// public static Map<Integer, String> PortCompress = new HashMap<Integer,
	// String>();
	// public static Map<Integer, String> PortHistory = new HashMap<Integer,
	// String>();
	public static Map<String, Server> TypeServer = new HashMap<String, Server>();
	public static Map<String, Integer> RecordAddress = new HashMap<String, Integer>();
	public static List<Record> RecordList = new ArrayList<Record>();

	// public static Map<String, Long> ps_NodeStatus = new HashMap<String,
	// Long>();
	public static Map<String, Long> ps_PointStatusUp = new HashMap<String, Long>();
	public static Map<String, Long> ps_PhysicalStatus = new HashMap<String, Long>();
	public static Map<String, Long> ps_ProjectStatus = new HashMap<String, Long>();
	public static Map<String, Long> ps_MeterStatusUp = new HashMap<String, Long>();
	public static Map<String, Long> ps_PointStatusDown = new HashMap<String, Long>();
	public static Map<String, Long> ps_MeterStatusDown = new HashMap<String, Long>();

	public static Map<String, List<String>> ps_PhysicalList = new HashMap<String, List<String>>();
	public static Map<String, List<String>> ps_ProjectList = new HashMap<String, List<String>>();
	public static Map<String, List<String>> ps_MeterList = new HashMap<String, List<String>>();

	public static Map<String, String> pointInfo = new HashMap<String, String>();
	public static Map<String, Data> nodeCache = new HashMap<String, Data>();
	public static Map<String, Data> pointCache = new HashMap<String, Data>();
	// public static Map<String, Long> pointListDown = new HashMap<String,
	// Long>();
	public static Map<String, Long> ps_ID2Time = new HashMap<String, Long>();
	public static Map<String, String> ps_ID2Point = new HashMap<String, String>();
	public static Map<String, String> ps_ID2Function = new HashMap<String, String>();
	public static Map<String, String> ps_ID2Status = new HashMap<String, String>();
	public static int collectRec = 0;
	public static int collectSend = 0;
	public static int sendRec = 0;
	public static int sendSend = 0;
	public static int writeDB = 0;
	public static int collectCount = 0;
	public static int collectReportCount = 0;
	public static int report2DBCount = 0;
	public static Map<String, String> pointMAC = new HashMap<String, String>();
	public static Map<String, String> black_Buildings = new HashMap<String, String>();
	public static Map<Integer, Integer> whilte_Funcs = new HashMap<Integer, Integer>();
	public static Map<String, Integer> pSeq = new HashMap<String, Integer>();
	public static Map<String, Integer> pMonth = new HashMap<String, Integer>();

	// static {
	// String resource = "\\config.json";
	// String path = null;
	// JsonParser config = new JsonParser();
	//
	// try {
	// LogUtil.info("System.get " + System.getProperty("user.dir") + resource);
	// LogUtil.info("LogUtil.get " + LogUtil.GetPath() + resource);
	// path = LogUtil.GetPath() + resource;
	//
	// JsonObject object = (JsonObject) config.parse(new FileReader(path));
	//
	// JsonArray db = object.get("DB").getAsJsonArray();
	// for (int i = 0; i < db.size(); i++) {
	// JsonObject subObject = db.get(i).getAsJsonObject();
	// if (subObject.get("building") != null) {
	// String building = subObject.get("building").getAsString();
	// Constant.BuildingDB.put(building,
	// subObject.get("database").getAsString());
	// Constant.Database = subObject.get("database").getAsString();
	//
	// if (subObject.get("buildingadds") != null) {
	// JsonArray buildingAdds = subObject.get("buildingadds").getAsJsonArray();
	// for (int j = 0; j < buildingAdds.size(); j++) {
	// JsonObject addObject = buildingAdds.get(j).getAsJsonObject();
	// if (!Constant.BuildingAdds.containsKey(building)) {
	// Constant.BuildingAdds.put(building, new ArrayList<String>());
	// }
	// Constant.BuildingAdds.get(building).add(addObject.get("building").getAsString());
	// Constant.BuildingDB.put(addObject.get("building").getAsString(),
	// subObject.get("database").getAsString());
	// Constant.Database = subObject.get("database").getAsString();
	// Constant.BuildingConv.put(addObject.get("building").getAsString(),
	// building);
	// }
	//
	// }
	// } else if (subObject.get("insertthread") != null) {
	// Constant.InsertThread = subObject.get("insertthread").getAsInt();
	// }
	// }
	// JsonArray port = object.get("Port").getAsJsonArray();
	// for (int i = 0; i < port.size(); i++) {
	// JsonObject subObject = port.get(i).getAsJsonObject();
	// String ports = subObject.get("port").getAsString();
	// Constant.TypePort.put(subObject.get("type").getAsString(), ports);
	// Constant.PortCompress.put(Integer.valueOf(ports),
	// subObject.get("Compress").getAsString());
	// Constant.PortHistory.put(Integer.valueOf(ports),
	// subObject.get("History").getAsString());
	// // for (String p : ports.split(",")) {
	// // Constant.PortCompress.put(Integer.valueOf(p),
	// // subObject.get("Compress").getAsString());
	// // Constant.PortHistory.put(Integer.valueOf(p),
	// // subObject.get("History").getAsString());
	// // }
	// }
	//
	// JsonArray blackList = object.get("BlackList").getAsJsonArray();
	// for (int i = 0; i < blackList.size(); i++) {
	// JsonObject subObject = blackList.get(i).getAsJsonObject();
	// if (subObject.get("buildings") != null) {
	// if (subObject.get("buildings") != null) {
	// JsonArray buildings = subObject.get("buildings").getAsJsonArray();
	// for (int j = 0; j < buildings.size(); j++) {
	// JsonObject addObject = buildings.get(j).getAsJsonObject();
	// Constant.black_Buildings.put(addObject.get("building").getAsString(),
	// null);
	// }
	// }
	// }
	// }
	//
	// JsonArray whiteList = object.get("WhiteList").getAsJsonArray();
	// for (int i = 0; i < whiteList.size(); i++) {
	// JsonObject subObject = whiteList.get(i).getAsJsonObject();
	// if (subObject.get("funcids") != null) {
	// if (subObject.get("funcids") != null) {
	// JsonArray funcids = subObject.get("funcids").getAsJsonArray();
	// for (int j = 0; j < funcids.size(); j++) {
	// JsonObject addObject = funcids.get(j).getAsJsonObject();
	// Constant.whilte_Funcs.put(addObject.get("funcid").getAsInt(), null);
	// }
	// }
	// }
	// }
	//
	// } catch (Exception e) {
	// // TODO Auto-generated catch block
	// // System.out.println(e.getMessage());
	// LogUtil.warn(e.toString());
	// LogUtil.warn("No Config File(config.json) in " + path + ",Now Exit!");
	// System.exit(0);
	// }
	//
	// }

	// public static long getWaitingtime() {
	// // TODO Auto-generated method stub
	// try {
	// if (WaitingTimeControl.contains("Second")) {
	// return Integer.valueOf(WaitingTimeControl.replace(" ",
	// "").replace("Second", ""))
	// * Constant.Millisecond.SECOND_1;
	// } else if (WaitingTimeControl.contains("second")) {
	// return Integer.valueOf(WaitingTimeControl.replace(" ",
	// "").replace("second", ""))
	// * Constant.Millisecond.SECOND_1;
	// } else {
	// return Constant.Millisecond.SECOND_3;
	// }
	// } catch (Exception e) {
	// return Constant.Millisecond.SECOND_3;
	// }
	// }

	public static Map<String, Integer> toLower(Map<String, Integer> pty) {
		// TODO Auto-generated method stub
		Map<String, Integer> result = new HashMap<String, Integer>();
		for (Entry<String, Integer> m : pty.entrySet()) {
			result.put(m.getKey().toLowerCase(), m.getValue());
			// Constant.info(m.getKey() + "-->" + m.getKey().toLowerCase());
		}
		return result;
	}

	public static long getWaitingtime() {
		// TODO Auto-generated method stub
		try {
			if (WaitingTimeControl.contains("Second")) {
				return Integer.valueOf(WaitingTimeControl.replace(" ", "").replace("Second", ""))
						* Constant.Millisecond.SECOND_1;
			} else if (WaitingTimeControl.contains("second")) {
				return Integer.valueOf(WaitingTimeControl.replace(" ", "").replace("second", ""))
						* Constant.Millisecond.SECOND_1;
			} else {
				return Constant.Millisecond.SECOND_3;
			}
		} catch (Exception e) {
			return Constant.Millisecond.SECOND_3;
		}
	}

	// @SuppressWarnings("rawtypes")
	// public static InetAddress getLocalHostLANAddress() throws
	// UnknownHostException {
	// try {
	// InetAddress candidateAddress = null;
	// // еӿ
	// for (Enumeration ifaces = NetworkInterface.getNetworkInterfaces();
	// ifaces.hasMoreElements();) {
	// NetworkInterface iface = (NetworkInterface) ifaces.nextElement();
	// // еĽӿٱIP
	// for (Enumeration inetAddrs = iface.getInetAddresses();
	// inetAddrs.hasMoreElements();) {
	// InetAddress inetAddr = (InetAddress) inetAddrs.nextElement();
	// if (!inetAddr.isLoopbackAddress()) {// ųloopback͵ַ
	// if (inetAddr.isSiteLocalAddress()) {
	// // site-localַ
	// return inetAddr;
	// } else if (candidateAddress == null) {
	// // site-local͵ĵַδ֣ȼ¼ѡַ
	// candidateAddress = inetAddr;
	// }
	// }
	// }
	// }
	// if (candidateAddress != null) {
	// return candidateAddress;
	// }
	// // ûз non-loopbackַ.ֻѡķ
	// InetAddress jdkSuppliedAddress = InetAddress.getLocalHost();
	// if (jdkSuppliedAddress == null) {
	// throw new UnknownHostException("The JDK InetAddress.getLocalHost() method
	// unexpectedly returned null.");
	// }
	// return jdkSuppliedAddress;
	// } catch (Exception e) {
	// UnknownHostException unknownHostException = new UnknownHostException(
	// "Failed to determine LAN address: " + e);
	// unknownHostException.initCause(e);
	// throw unknownHostException;
	// }
	// }

	private static final SimpleDateFormat SIMPLEDATEFORMAT = new SimpleDateFormat("yyyyMMddHHmmss");
	private static final SimpleDateFormat SIMPLEDATEFORMATDB = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
	private static final SimpleDateFormat SIMPLEDATEFORMAT_Minute = new SimpleDateFormat("yyyyMMddHHmm");
	private static final SimpleDateFormat SIMPLEDATEFORMAT_DAY = new SimpleDateFormat("yyyyMMdd");
	private static final SimpleDateFormat SIMPLEDATEFORMAT_MONTH = new SimpleDateFormat("yyyyMM");
	private static final SimpleDateFormat SIMPLEDATEFORMATLOG = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss SSS");
	// private static final SimpleDateFormat SIMPLEDATEFORMAT_LOG = new
	// SimpleDateFormat("yyyyMMddHHmmssSSS");

	// public synchronized static String format_LOG(Date value) {
	// return SIMPLEDATEFORMAT_LOG.format(value);
	// }

	public synchronized static String format_Minute(Date value) {
		return SIMPLEDATEFORMAT_Minute.format(value);
	}

	public synchronized static String format_DB(Date value) {
		return SIMPLEDATEFORMATDB.format(value);
	}

	public synchronized static String format_Log(Date value) {
		return SIMPLEDATEFORMATLOG.format(value);
	}

	// public synchronized static Date parse_LOG(String value) throws
	// ParseException {
	// return SIMPLEDATEFORMAT_LOG.parse(value);
	// }

	public synchronized static Date parse_Minute(String value) throws ParseException {
		return SIMPLEDATEFORMAT_Minute.parse(value);
	}

	public synchronized static Date parse_DB(String value) throws ParseException {
		return SIMPLEDATEFORMATDB.parse(value);
	}

	public synchronized static Date parse_MONTH(String value) throws ParseException {
		return SIMPLEDATEFORMAT_MONTH.parse(value);
	}

	public synchronized static String format(Date value) {
		if (value == null) {
			return "null";
		}
		return SIMPLEDATEFORMAT.format(value);
	}

	public synchronized static Date parse(String value) throws ParseException {
		return SIMPLEDATEFORMAT.parse(value);
	}

	public synchronized static String format_day(Date value) {
		return SIMPLEDATEFORMAT_DAY.format(value);
	}

	public synchronized static String format_month(Date value) {
		return SIMPLEDATEFORMAT_MONTH.format(value);
	}

	public synchronized static Date parse_day(String value) throws ParseException {
		return SIMPLEDATEFORMAT_DAY.parse(value);
	}

	public static void showStatus() {
		// TODO Auto-generated method stub
		LogUtil.info("ps_PointStatusUp:");
		for (Entry<String, Long> d : Constant.ps_PointStatusUp.entrySet()) {
			LogUtil.info(d.getKey() + " " + Constant.format(new Date(d.getValue())));
		}
		LogUtil.info("-----------------------------------------------------");
		LogUtil.info("ps_PhysicalStatus:");
		for (Entry<String, Long> d : Constant.ps_PhysicalStatus.entrySet()) {
			LogUtil.info(d.getKey() + " " + Constant.format(new Date(d.getValue())));
		}
		LogUtil.info("-----------------------------------------------------");
		LogUtil.info("ps_ProjectStatus:");
		for (Entry<String, Long> d : Constant.ps_ProjectStatus.entrySet()) {
			LogUtil.info(d.getKey() + " " + Constant.format(new Date(d.getValue())));
		}
		LogUtil.info("-----------------------------------------------------");
		LogUtil.info("ps_MeterStatusUp:");
		for (Entry<String, Long> d : Constant.ps_MeterStatusUp.entrySet()) {
			LogUtil.info(d.getKey() + " " + Constant.format(new Date(d.getValue())));
		}
		LogUtil.info("-----------------------------------------------------");
		LogUtil.info("ps_PointStatusDown:");
		for (Entry<String, Long> d : Constant.ps_PointStatusDown.entrySet()) {
			LogUtil.info(d.getKey() + " " + Constant.format(new Date(d.getValue())));
		}
		LogUtil.info("-----------------------------------------------------");
		LogUtil.info("ps_MeterStatusDown:");
		for (Entry<String, Long> d : Constant.ps_MeterStatusDown.entrySet()) {
			LogUtil.info(d.getKey() + " " + Constant.format(new Date(d.getValue())));
		}
		LogUtil.info("-----------------------------------------------------");
		LogUtil.info("ps_PhysicalList:\n" + Constant.ps_PhysicalList);
		LogUtil.info("-----------------------------------------------------");
		LogUtil.info("ps_ProjectList:\n" + Constant.ps_ProjectList);
		LogUtil.info("-----------------------------------------------------");
		LogUtil.info("ps_MeterList:\n" + Constant.ps_MeterList);
		LogUtil.info("-----------------------------------------------------");

	}

	// public static void Insert_agents_ps_physical_log(String project, String
	// address_1, String address_2,
	// String address_3, String address_4, String receivetime, String status) {
	// // TODO Auto-generated method stub
	// try {
	// HBaseUtil.Insert_ps_physical_log(Constant.BuildingDB.get(project),
	// project, address_1, address_2, address_3,
	// address_4, receivetime, status);
	// LogUtil.info(agent.getFull_name() + " insert into ps_physical_log " + "
	// project " + project + " address_1 "
	// + address_1 + " address_2 " + address_2 + " address_3 " + address_3 + "
	// address_4 " + address_4
	// + " receivetime " + receivetime + " status " + status);
	// } catch (Exception e) {
	// // TODO Auto-generated catch block
	// e.printStackTrace();
	// }
	//
	// }
	//
	// public static void Insert_agents_ps_physical_status(String project,
	// String address_1, String address_2,
	// String address_3, String address_4, String status, String receivetime,
	// String detail) {
	// // TODO Auto-generated method stub
	// try {
	// HBaseUtil.Insert_ps_physical_status(Constant.BuildingDB.get(project),
	// project, address_1, address_2,
	// address_3, address_4, status, receivetime, detail);
	// LogUtil.info(agent.getFull_name() + " insert into ps_physical_status " +
	// " project " + project
	// + " address_1 " + address_1 + " address_2 " + address_2 + " address_3 " +
	// address_3 + " address_4 "
	// + address_4 + " receivetime " + receivetime + " status " + status);
	// } catch (Exception e) {
	// // TODO Auto-generated catch block
	// e.printStackTrace();
	// }
	// }
	//
	// public static void Insert_agents_ps_virtual_meter_log(String project,
	// String meter, String updown,
	// String receivetime, String status) {
	// // TODO Auto-generated method stub
	//
	// try {
	// HBaseUtil.Insert_ps_virtual_meter_log(Constant.BuildingDB.get(project),
	// project, meter, updown, receivetime,
	// status);
	// LogUtil.info(agent.getFull_name() + " insert into ps_virtual_meter_log "
	// + " project " + project + " meter "
	// + meter + " updown " + updown + " receivetime " + receivetime + " status
	// " + status);
	// } catch (Exception e) {
	// // TODO Auto-generated catch block
	// e.printStackTrace();
	// }
	// }
	//
	// public static void Insert_agents_ps_virtual_meter_status(String project,
	// String meter, String updown, String status,
	// String receivetime, String detail) {
	// // TODO Auto-generated method stub
	// try {
	// HBaseUtil.Insert_ps_virtual_meter_status(Constant.BuildingDB.get(project),
	// project, meter, updown, status,
	// receivetime, detail);
	// LogUtil.info(agent.getFull_name() + " insert into ps_virtual_meter_status
	// " + " project " + project
	// + " meter " + meter + " updown " + updown + " receivetime " + receivetime
	// + " status " + status);
	// } catch (Exception e) {
	// // TODO Auto-generated catch block
	// e.printStackTrace();
	// }
	// }
	//
	// public static void Insert_agents_ps_virtual_point_log(String building,
	// String meter, Long funcid, String updown,
	// Long time, Long seq, String status, String feedback) {
	// // TODO Auto-generated method stub
	// try {
	// if (time == null || time == 0) {
	// HBaseUtil.Insert_ps_virtual_point_log(Constant.BuildingDB.get(building),
	// building, meter,
	// Long.valueOf(funcid), updown, Constant.format(new Date()), seq, status,
	// feedback);
	// } else {
	// HBaseUtil.Insert_ps_virtual_point_log(Constant.BuildingDB.get(building),
	// building, meter,
	// Long.valueOf(funcid), updown, Constant.format(new Date(time)), seq,
	// status, feedback);
	// }
	// LogUtil.info(agent.getFull_name() + " insert into ps_virtual_point_log "
	// + " building " + building
	// + " meter " + meter + " updown " + updown + " funcid " + funcid + "
	// status " + status + " feedback "
	// + feedback);
	// } catch (Exception e) {
	// // TODO Auto-generated catch block
	// e.printStackTrace();
	// }
	// }
	//
	// public static void Insert_agents_ps_virtual_point_status(String building,
	// String meter, Long funcid, String updown,
	// String status, Long time, String detail) {
	// // TODO Auto-generated method stub
	// try {
	// if (time == null || time == 0) {
	// HBaseUtil.Insert_ps_virtual_point_status(Constant.BuildingDB.get(building),
	// building, meter,
	// Long.valueOf(funcid), "up", status, Constant.format(new Date()), "");
	//
	// } else {
	// HBaseUtil.Insert_ps_virtual_point_status(Constant.BuildingDB.get(building),
	// building, meter,
	// Long.valueOf(funcid), "up", status, Constant.format(new Date(time)), "");
	// }
	// LogUtil.info(agent.getFull_name() + " insert into ps_virtual_point_status
	// " + " building " + building
	// + " meter " + meter + " updown " + updown + " funcid " + funcid + "
	// status " + status + " detail "
	// + detail);
	// } catch (Exception e) {
	// // TODO Auto-generated catch block
	// e.printStackTrace();
	// }
	// }
	//
	// public static void Insert_agents_ps_virtual_project_log(String project,
	// String receivetime, String status) {
	// // TODO Auto-generated method stub
	// try {
	// HBaseUtil.Insert_ps_virtual_project_log(Constant.BuildingDB.get(project),
	// project, receivetime, status);
	// LogUtil.info(agent.getFull_name() + " insert into ps_virtual_project_log
	// " + " project " + project
	// + " receivetime " + receivetime + " status " + status);
	// } catch (Exception e) {
	// // TODO Auto-generated catch block
	// e.printStackTrace();
	// }
	//
	// }
	//
	// public static void Insert_agents_ps_virtual_project_status(String
	// project, String status, String receivetime,
	// String detail) {
	// // TODO Auto-generated method stub
	// try {
	// HBaseUtil.Insert_ps_virtual_project_status(Constant.BuildingDB.get(project),
	// project, status, receivetime,
	// detail);
	// LogUtil.info(agent.getFull_name() + " insert into
	// ps_virtual_project_status " + " project " + project
	// + " receivetime " + receivetime + " status " + status);
	// } catch (Exception e) {
	// // TODO Auto-generated catch block
	// e.printStackTrace();
	// }
	// }

	// public static List<String> getConfigFile(String directoryPath, String
	// directoryKey, String fileKey) {
	// List<String> list = new ArrayList<String>();
	// File baseFile = new File(directoryPath);
	// if (baseFile.isFile() || !baseFile.exists()) {
	// return list;
	// }
	// try {
	// File[] files = baseFile.listFiles();
	// SAXReader saxReader = new SAXReader();
	// for (File file : files) {
	// if (file.isDirectory() && file.getName().contains(directoryKey)) {
	// list.addAll(getConfigFile(file.getAbsolutePath(), directoryKey,
	// fileKey));
	// } else {
	// if (file.getName().contains(fileKey)) {
	// list.add(file.getAbsolutePath());
	// Document document = saxReader.read(file);
	// List<Element> devList = document.selectNodes("/root/portdev/devtype");
	// // System.out.println(file.getName());
	// // System.out.println(file.getName().indexOf(fileKey));
	// // System.out.println(file.getName().indexOf(".xml"));
	// String port = file.getName().substring(file.getName().indexOf(fileKey) +
	// fileKey.length(),
	// file.getName().indexOf(".xml"));
	// // System.out.println(port);
	// // System.out.println(file.getParentFile().getName());
	// // String building =
	// // file.getParentFile().getName().replace(directoryKey,
	// // "").substring(0, 10);
	// // String mac =
	// // file.getParentFile().getName().replace(directoryKey,
	// // "").substring(10);
	// String building = file.getParentFile().getName().replace(directoryKey,
	// "").split("-")[0];
	// String mac = file.getParentFile().getName().replace(directoryKey,
	// "").split("-")[1];
	// // System.out.println(building);
	// // System.out.println(mac);
	//
	// for (Element portdev : devList) {
	// String meter = portdev.attributeValue("meterid");
	// String info = port + "-" + portdev.element("addr").getText();
	// String point = building + "-" + mac + "-" + meter;
	// Constant.pointInfo.put(point, info);
	// // Iterator funcList =
	// // portdev.selectNodes("funset/funid").iterator();
	// // while (funcList.hasNext()) {
	// // Element func = (Element) funcList.next();
	// // String point = building + "-" + mac + "-" + meter
	// // + "." + func.getText();
	// // String info = port + "-" +
	// // portdev.element("addr").getText();
	// // Constant.pointInfo.put(point, info);
	// // System.out.println(meter + "." +
	// // func.getText());
	// // }
	// }
	//
	// }
	// }
	// }
	// } catch (Exception e) {
	// // TODO Auto-generated catch block
	// e.printStackTrace();
	// }
	//
	// return list;
	// }

	public synchronized static int getSeq(String point) {
		int month = Integer.valueOf(Constant.format_month(new Date()).substring(4));
		if (Constant.pMonth.containsKey(point) && (month == Constant.pMonth.get(point))) {
			int seq = Constant.pSeq.get(point) + 1;
			Constant.pMonth.put(point, month);
			Constant.pSeq.put(point, seq);
			return seq;
		}
		Constant.pMonth.put(point, month);
		Constant.pSeq.put(point, 1);
		return 1;
	}

	public synchronized static int getID() {
		if (PacketId > 65535) {
			PacketId = 1;
		} else {
			PacketId = PacketId + 1;
		}
		return PacketId;
	}

	public static class Millisecond {
		public static final long SECOND_1 = 1000L;
		public static final long SECOND_3 = 1000L * 3;
		public static final long SECOND_10 = 1000L * 10;
		public static final long SECOND_20 = 1000L * 20;
		public static final long SECOND_30 = 1000L * 30;
		public static final long MINUTE_1 = 1000L * 60 * 1;
		public static final long MINUTE_3 = 1000L * 60 * 3;
		public static final long MINUTE_5 = 1000L * 60 * 5;
		public static final long MINUTE_10 = 1000L * 60 * 10;
		public static final long MINUTE_15 = 1000L * 60 * 15;
		public static final long MINUTE_30 = 1000L * 60 * 30;
		public static final long MINUTE_60 = 1000L * 60 * 60;
		public static final long MINUTE_1440 = 1000L * 60 * 60 * 24;
		public static final long HOUR = 1000L * 60 * 60;
		public static final long DAY = 1000L * 60 * 60 * 24;

	}

	public static long getMillisecond(String request) {
		// TODO Auto-generated method stub
		try {
			if (request.contains("Second")) {
				return Integer.valueOf(request.replace(" ", "").replace("Second", "")) * Constant.Millisecond.SECOND_1;
			} else if (request.contains("second")) {
				return Integer.valueOf(request.replace(" ", "").replace("second", "")) * Constant.Millisecond.SECOND_1;
			} else if (request.contains("min")) {
				return Millisecond.MINUTE_1 * Integer.valueOf(request.replace("min", "").replace(" ", ""));
			} else {
				return Constant.Millisecond.SECOND_20;
			}
		} catch (Exception e) {
			return Constant.Millisecond.SECOND_20;
		}
	}

	public static void Insert_dy_pointlist(String building, String meter, Integer funcid, String system, String source,
			String address1, String ip_port, String address2, String address3, String address4, String collect_cycle,
			String data_type, String unit) {
		// TODO Auto-generated method stub
		try {
			if (Constant.DbConnection.containsKey("Db-Mysql") && Constant.DbConnection.get("Db-Mysql") != null) {
				MySQLUtil.Insert_dy_pointlist(Constant.Database, building, meter, funcid, system, source, address1,
						ip_port, address2, "", "", collect_cycle, data_type, unit);
				LogUtil.info(
						"insert into dy_pointlist " + "building " + building + " meter " + meter + " funcid " + funcid);
			} else {
				HBaseUtil.Insert_dy_pointlist(Constant.Database, building, meter, funcid, system, source, address1,
						ip_port, address2, "", "", collect_cycle, data_type, unit);
				LogUtil.info(agent.getFull_name() + " insert into dy_pointlist " + "building " + building + " meter "
						+ meter + " funcid " + funcid);
			}
		} catch (Exception e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}

	// public static void AgentsBatchInsert(String db, List<Record>
	// wtdbrecordList) {
	// // TODO Auto-generated method stub
	//
	// try {
	// HBaseUtil.BatchInsert(db, wtdbrecordList);
	// } catch (Exception e) {
	// // TODO Auto-generated catch block
	// e.printStackTrace();
	// }
	//
	// }
	//
	// public static void AgentsBatchInsert_Set2(String db, PointSet ps) {
	// // TODO Auto-generated method stub
	//
	// try {
	// HBaseUtil.BatchInsert_Set2(db, ps);
	// } catch (Exception e) {
	// // TODO Auto-generated catch block
	// e.printStackTrace();
	// }
	// }
	//
	// public static void AgentsBatchInsert_Set3(String db, PointSet ps) {
	// // TODO Auto-generated method stub
	// try {
	// HBaseUtil.BatchInsert_Set3(db, ps);
	// } catch (Exception e) {
	// // TODO Auto-generated catch block
	// e.printStackTrace();
	// }
	// }
	//
	// public static void AgentsBatchInsert_Set1(String db, PointSet ps) {
	// // TODO Auto-generated method stub
	// try {
	// HBaseUtil.BatchInsert_Set1(db, ps);
	// } catch (Exception e) {
	// // TODO Auto-generated catch block
	// e.printStackTrace();
	// }
	// }

	public static Map<String, List<Integer>> GetDBPointList2Cache(String db, String tb, String building) {
		// TODO Auto-generated method stub
		Map<String, List<Integer>> dbPointList = new HashMap<String, List<Integer>>();
		try {
			Map<String, List<Integer>> pl = GetDBPointList(db, tb, building);
			for (Entry<String, List<Integer>> m : pl.entrySet()) {
				if (!dbPointList.containsKey(m.getKey())) {
					dbPointList.put(m.getKey(), new ArrayList<Integer>());
				}
				for (Integer f : m.getValue()) {
					if (!dbPointList.get(m.getKey()).contains(f)) {
						dbPointList.get(m.getKey()).add(f);
					}
				}
			}
		} catch (Exception e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}

		return dbPointList;
	}

	public static void loadDB2Cache_dy_pointlist() {
		// TODO Auto-generated method stub
		try {
			Constant.LoadDB2Cache_dy_pointlist(Constant.Database, "dy_pointlist");
		} catch (Exception e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}

	public static Map<String, String> ps_physical_status(String db, String tb) throws Exception {
		if (Constant.DbConnection.containsKey("Db-Mysql") && Constant.DbConnection.get("Db-Mysql") != null) {
			return MySQLUtil.ps_physical_status(db, tb);
		} else {
			return HBaseUtil.ps_physical_status(db, tb);
		}
	}

	public static Map<String, String> ps_virtual_point_status(String db, String tb) throws Exception {
		if (Constant.DbConnection.containsKey("Db-Mysql") && Constant.DbConnection.get("Db-Mysql") != null) {
			return MySQLUtil.ps_virtual_point_status(db, tb);
		} else {
			return HBaseUtil.ps_virtual_point_status(db, tb);
		}
	}

	public static Map<String, String> ps_virtual_meter_status(String db, String tb) throws Exception {
		if (Constant.DbConnection.containsKey("Db-Mysql") && Constant.DbConnection.get("Db-Mysql") != null) {
			return MySQLUtil.ps_virtual_meter_status(db, tb);
		} else {
			return HBaseUtil.ps_virtual_meter_status(db, tb);
		}
	}

	public static Map<String, String> ps_virtual_project_status(String db, String tb) throws Exception {
		if (Constant.DbConnection.containsKey("Db-Mysql") && Constant.DbConnection.get("Db-Mysql") != null) {
			return MySQLUtil.ps_virtual_project_status(db, tb);
		} else {
			return HBaseUtil.ps_virtual_project_status(db, tb);
		}
	}

	public static void LoadDB2Cache_dy_pointlist(String db, String tb) throws Exception {
		if (Constant.DbConnection.containsKey("Db-Mysql") && Constant.DbConnection.get("Db-Mysql") != null) {
			MySQLUtil.LoadDB2Cache_dy_pointlist(db, tb);
		} else {
			HBaseUtil.LoadDB2Cache_dy_pointlist(db, tb);
		}
	}

	public static void LoadDB2Cache_ps_physical_status(String db, String tb) throws Exception {
		if (Constant.DbConnection.containsKey("Db-Mysql") && Constant.DbConnection.get("Db-Mysql") != null) {
			MySQLUtil.LoadDB2Cache_ps_physical_status(db, tb);
		} else {
			HBaseUtil.LoadDB2Cache_ps_physical_status(db, tb);
		}
	}

	public static void LoadDB2Cache_ps_virtual_point_status(String db, String tb) throws Exception {
		if (Constant.DbConnection.containsKey("Db-Mysql") && Constant.DbConnection.get("Db-Mysql") != null) {
			MySQLUtil.LoadDB2Cache_ps_virtual_point_status(db, tb);
		} else {
			HBaseUtil.LoadDB2Cache_ps_virtual_point_status(db, tb);
		}
	}

	public static void LoadDB2Cache_ps_virtual_meter_status(String db, String tb) throws Exception {
		if (Constant.DbConnection.containsKey("Db-Mysql") && Constant.DbConnection.get("Db-Mysql") != null) {
			MySQLUtil.LoadDB2Cache_ps_virtual_meter_status(db, tb);
		} else {
			HBaseUtil.LoadDB2Cache_ps_virtual_meter_status(db, tb);
		}
	}

	public static void LoadDB2Cache_ps_virtual_project_status(String db, String tb) throws Exception {
		if (Constant.DbConnection.containsKey("Db-Mysql") && Constant.DbConnection.get("Db-Mysql") != null) {
			MySQLUtil.LoadDB2Cache_ps_virtual_project_status(db, tb);
		} else {
			HBaseUtil.LoadDB2Cache_ps_virtual_project_status(db, tb);
		}
	}

	public static Map<String, List<Integer>> GetDBPointList(String db, String tb, String building) throws Exception {
		if (Constant.DbConnection.containsKey("Db-Mysql") && Constant.DbConnection.get("Db-Mysql") != null) {
			return MySQLUtil.GetDBPointList(db, tb, building);
		} else {
			return HBaseUtil.GetDBPointList(db, tb, building);
		}
	}

	public static void Getset(String db, String tb, String building, String meter, long funcid, String query_from,
			String query_to) throws Exception {
		if (Constant.DbConnection.containsKey("Db-Mysql") && Constant.DbConnection.get("Db-Mysql") != null) {
			MySQLUtil.Getset(db, tb, building, meter, funcid, query_from, query_to);
		} else {
			HBaseUtil.Getset(db, tb, building, meter, funcid, query_from, query_to);
		}
	}

	public static void Getset_present(String db, String tb, String building, String meter, long funcid)
			throws Exception {
		if (Constant.DbConnection.containsKey("Db-Mysql") && Constant.DbConnection.get("Db-Mysql") != null) {
			MySQLUtil.Getset_present(db, tb, building, meter, funcid);
		} else {
			HBaseUtil.Getset_present(db, tb, building, meter, funcid);
		}
	}

	public static void CreateDB(String DB) throws Exception {
		try {
			if (Constant.DbConnection.containsKey("Db-Mysql") && Constant.DbConnection.get("Db-Mysql") != null) {
				MySQLUtil.CreateDB(DB);
			} else {
				HBaseUtil.CreateDB(DB);
			}
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	public static boolean tableExist(String DBName, String tableName) throws Exception {
		if (Constant.DbConnection.containsKey("Db-Mysql") && Constant.DbConnection.get("Db-Mysql") != null) {
			return MySQLUtil.tableExist(DBName, tableName);
		} else {
			return HBaseUtil.tableExist(DBName, tableName);
		}
	}

	public static void CreateTable(String DB, String tableName) throws Exception {
		if (Constant.DbConnection.containsKey("Db-Mysql") && Constant.DbConnection.get("Db-Mysql") != null) {
			MySQLUtil.CreateTable(DB, tableName);
		} else {
			HBaseUtil.CreateTable(DB, tableName);
		}
	}

	public static void CreateTable_present(String DB, String tableName) throws Exception {
		if (Constant.DbConnection.containsKey("Db-Mysql") && Constant.DbConnection.get("Db-Mysql") != null) {
			MySQLUtil.CreateTable_present(DB, tableName);
		} else {
			HBaseUtil.CreateTable_present(DB, tableName);
		}
	}

	public static void CreateTable_set(String DB, String tableName) throws Exception {
		if (Constant.DbConnection.containsKey("Db-Mysql") && Constant.DbConnection.get("Db-Mysql") != null) {
			MySQLUtil.CreateTable_set(DB, tableName);
		} else {
			HBaseUtil.CreateTable_set(DB, tableName);
		}
	}

	public static void CreateTable_setpresent(String DB, String tableName) throws Exception {
		if (Constant.DbConnection.containsKey("Db-Mysql") && Constant.DbConnection.get("Db-Mysql") != null) {
			MySQLUtil.CreateTable_setpresent(DB, tableName);
		} else {
			HBaseUtil.CreateTable_setpresent(DB, tableName);
		}
	}

	public static void CreateTable_fjd_0_buildingcomputetime(String DB, String tableName) throws Exception {
		if (Constant.DbConnection.containsKey("Db-Mysql") && Constant.DbConnection.get("Db-Mysql") != null) {
			MySQLUtil.CreateTable_fjd_0_buildingcomputetime(DB, tableName);
		} else {
			HBaseUtil.CreateTable_fjd_0_buildingcomputetime(DB, tableName);
		}
	}

	public static void CreateTable_dy_pointlist(String DB, String tableName) throws Exception {
		if (Constant.DbConnection.containsKey("Db-Mysql") && Constant.DbConnection.get("Db-Mysql") != null) {
			MySQLUtil.CreateTable_dy_pointlist(DB, tableName);
		} else {
			HBaseUtil.CreateTable_dy_pointlist(DB, tableName);
		}
	}

	public static void CreateTable_ps_physical_status(String DB, String tableName) throws Exception {
		if (Constant.DbConnection.containsKey("Db-Mysql") && Constant.DbConnection.get("Db-Mysql") != null) {
			MySQLUtil.CreateTable_ps_physical_status(DB, tableName);
		} else {
			HBaseUtil.CreateTable_ps_physical_status(DB, tableName);
		}
	}

	public static void CreateTable_ps_physical_log(String DB, String tableName) throws Exception {
		if (Constant.DbConnection.containsKey("Db-Mysql") && Constant.DbConnection.get("Db-Mysql") != null) {
			MySQLUtil.CreateTable_ps_physical_log(DB, tableName);
		} else {
			HBaseUtil.CreateTable_ps_physical_log(DB, tableName);
		}
	}

	public static void CreateTable_ps_virtual_point_status(String DB, String tableName) throws Exception {
		if (Constant.DbConnection.containsKey("Db-Mysql") && Constant.DbConnection.get("Db-Mysql") != null) {
			MySQLUtil.CreateTable_ps_virtual_point_status(DB, tableName);
		} else {
			HBaseUtil.CreateTable_ps_virtual_point_status(DB, tableName);
		}
	}

	public static void CreateTable_ps_virtual_point_log(String DB, String tableName) throws Exception {
		if (Constant.DbConnection.containsKey("Db-Mysql") && Constant.DbConnection.get("Db-Mysql") != null) {
			MySQLUtil.CreateTable_ps_virtual_point_log(DB, tableName);
		} else {
			HBaseUtil.CreateTable_ps_virtual_point_log(DB, tableName);
		}
	}

	public static void CreateTable_ps_virtual_meter_status(String DB, String tableName) throws Exception {
		if (Constant.DbConnection.containsKey("Db-Mysql") && Constant.DbConnection.get("Db-Mysql") != null) {
			MySQLUtil.CreateTable_ps_virtual_meter_status(DB, tableName);
		} else {
			HBaseUtil.CreateTable_ps_virtual_meter_status(DB, tableName);
		}
	}

	public static void CreateTable_ps_virtual_meter_log(String DB, String tableName) throws Exception {
		if (Constant.DbConnection.containsKey("Db-Mysql") && Constant.DbConnection.get("Db-Mysql") != null) {
			MySQLUtil.CreateTable_ps_virtual_meter_log(DB, tableName);
		} else {
			HBaseUtil.CreateTable_ps_virtual_meter_log(DB, tableName);
		}
	}

	public static void CreateTable_ps_virtual_project_status(String DB, String tableName) throws Exception {
		if (Constant.DbConnection.containsKey("Db-Mysql") && Constant.DbConnection.get("Db-Mysql") != null) {
			MySQLUtil.CreateTable_ps_virtual_project_status(DB, tableName);
		} else {
			HBaseUtil.CreateTable_ps_virtual_project_status(DB, tableName);
		}
	}

	public static void CreateTable_ps_virtual_project_log(String DB, String tableName) throws Exception {
		if (Constant.DbConnection.containsKey("Db-Mysql") && Constant.DbConnection.get("Db-Mysql") != null) {
			MySQLUtil.CreateTable_ps_virtual_project_log(DB, tableName);
		} else {
			HBaseUtil.CreateTable_ps_virtual_project_log(DB, tableName);
		}
	}

	public static void Insert_fjd_0_buildingcomputetime(String DB, String building, String compute_time,
			String first_compute_time) throws Exception {
		if (Constant.DbConnection.containsKey("Db-Mysql") && Constant.DbConnection.get("Db-Mysql") != null) {
			MySQLUtil.Insert_fjd_0_buildingcomputetime(DB, building, compute_time, first_compute_time);
		} else {
			HBaseUtil.Insert_fjd_0_buildingcomputetime(DB, building, compute_time, first_compute_time);
		}
	}

	public static void Insert_ps_physical_status(String DB, String project, String address_1, String address_2,
			String address_3, String address_4, String status, String receivetime, String detail) throws Exception {
		if (Constant.DbConnection.containsKey("Db-Mysql") && Constant.DbConnection.get("Db-Mysql") != null) {
			MySQLUtil.Insert_ps_physical_status(DB, project, address_1, address_2, address_3, address_4, status,
					receivetime, detail);
		} else {
			HBaseUtil.Insert_ps_physical_status(DB, project, address_1, address_2, address_3, address_4, status,
					receivetime, detail);
		}
	}

	public static void Insert_ps_physical_log(String DB, String project, String address_1, String address_2,
			String address_3, String address_4, String receivetime, String function) throws Exception {
		if (Constant.DbConnection.containsKey("Db-Mysql") && Constant.DbConnection.get("Db-Mysql") != null) {
			MySQLUtil.Insert_ps_physical_log(DB, project, address_1, address_2, address_3, address_4, receivetime,
					function);
		} else {
			HBaseUtil.Insert_ps_physical_log(DB, project, address_1, address_2, address_3, address_4, receivetime,
					function);
		}
	}

	public static void Insert_ps_virtual_point_status(String DB, String project, String meter, long funcid,
			String updown, String status, String receivetime, String detail) throws Exception {
		if (receivetime == null || Constant.parse(receivetime).getTime() == 0) {
			receivetime = Constant.format(new Date());
		}
		if (Constant.DbConnection.containsKey("Db-Mysql") && Constant.DbConnection.get("Db-Mysql") != null) {
			MySQLUtil.Insert_ps_virtual_point_status(DB, project, meter, funcid, updown, status, receivetime, detail);
		} else {
			HBaseUtil.Insert_ps_virtual_point_status(DB, project, meter, funcid, updown, status, receivetime, detail);
		}
	}

	public static void Insert_ps_virtual_point_log(String DB, String project, String meter, long funcid, String updown,
			String receivetime, long seq, String function, String feedback) throws Exception {

		if (receivetime == null || Constant.parse(receivetime).getTime() == 0) {
			receivetime = Constant.format(new Date());
		}

		if (Constant.DbConnection.containsKey("Db-Mysql") && Constant.DbConnection.get("Db-Mysql") != null) {
			MySQLUtil.Insert_ps_virtual_point_log(DB, project, meter, funcid, updown, receivetime, seq, function,
					feedback);
		} else {
			HBaseUtil.Insert_ps_virtual_point_log(DB, project, meter, funcid, updown, receivetime, seq, function,
					feedback);
		}
	}

	public static void Insert_ps_virtual_meter_status(String DB, String project, String meter, String updown,
			String status, String receivetime, String detail) throws Exception {
		if (Constant.DbConnection.containsKey("Db-Mysql") && Constant.DbConnection.get("Db-Mysql") != null) {
			MySQLUtil.Insert_ps_virtual_meter_status(DB, project, meter, updown, status, receivetime, detail);
		} else {
			HBaseUtil.Insert_ps_virtual_meter_status(DB, project, meter, updown, status, receivetime, detail);
		}
	}

	public static void Insert_ps_virtual_meter_log(String DB, String project, String meter, String updown,
			String receivetime, String function) throws Exception {
		if (Constant.DbConnection.containsKey("Db-Mysql") && Constant.DbConnection.get("Db-Mysql") != null) {
			MySQLUtil.Insert_ps_virtual_meter_log(DB, project, meter, updown, receivetime, function);
		} else {
			HBaseUtil.Insert_ps_virtual_meter_log(DB, project, meter, updown, receivetime, function);
		}
	}

	public static void Insert_ps_virtual_project_status(String DB, String project, String status, String receivetime,
			String detail) throws Exception {
		if (Constant.DbConnection.containsKey("Db-Mysql") && Constant.DbConnection.get("Db-Mysql") != null) {
			MySQLUtil.Insert_ps_virtual_project_status(DB, project, status, receivetime, detail);
		} else {
			HBaseUtil.Insert_ps_virtual_project_status(DB, project, status, receivetime, detail);
		}
	}

	public static void Insert_ps_virtual_project_log(String DB, String project, String receivetime, String function)
			throws Exception {
		if (Constant.DbConnection.containsKey("Db-Mysql") && Constant.DbConnection.get("Db-Mysql") != null) {
			MySQLUtil.Insert_ps_virtual_project_log(DB, project, receivetime, function);
		} else {
			HBaseUtil.Insert_ps_virtual_project_log(DB, project, receivetime, function);
		}
	}

	public static void BatchInsert(String DB, List<Record> dataList) throws Exception {
		if (Constant.DbConnection.containsKey("Db-Mysql") && Constant.DbConnection.get("Db-Mysql") != null) {
			MySQLUtil.BatchInsert(DB, dataList);
		} else {
			HBaseUtil.BatchInsert(DB, dataList);
		}
	}

	public static void BatchInsert_Set1(String DB, PointSet ps) throws Exception {
		if (Constant.DbConnection.containsKey("Db-Mysql") && Constant.DbConnection.get("Db-Mysql") != null) {
			MySQLUtil.BatchInsert_Set1(DB, ps);
		} else {
			HBaseUtil.BatchInsert_Set1(DB, ps);
		}
	}

	public static void BatchInsert_Set2(String DB, PointSet ps) throws Exception {
		if (Constant.DbConnection.containsKey("Db-Mysql") && Constant.DbConnection.get("Db-Mysql") != null) {
			MySQLUtil.BatchInsert_Set2(DB, ps);
		} else {
			HBaseUtil.BatchInsert_Set2(DB, ps);
		}
	}

	public static void BatchInsert_Set3(String DB, PointSet ps) throws Exception {
		if (Constant.DbConnection.containsKey("Db-Mysql") && Constant.DbConnection.get("Db-Mysql") != null) {
			MySQLUtil.BatchInsert_Set3(DB, ps);
		} else {
			HBaseUtil.BatchInsert_Set3(DB, ps);
		}
	}

	public static Date getOffSetTime(Record record) {
		// TODO Auto-generated method stub
		if (Constant.BuildingOffset.containsKey(record.buildingSign)
				&& Constant.BuildingOffset.get(record.buildingSign)) {
			return new Date(record.receivetime.getTime() + 8 * Constant.Millisecond.HOUR);
		}
		return record.receivetime;
	}

	public static int getFunctionConv(Record record) {
		// TODO Auto-generated method stub
		if (Constant.FunctionConv.containsKey(record.funcID) && Constant.FunctionConv.get(record.funcID) != null) {
			return Integer.valueOf(Constant.FunctionConv.get(record.funcID));
		}
		return record.funcID;
	}

	public static void CreateTable_upload(String DB, List<String> uploadList) throws Exception {
		if (Constant.DbConnection.containsKey("Db-Mysql") && Constant.DbConnection.get("Db-Mysql") != null) {
			MySQLUtil.CreateTable_upload(DB, uploadList);
		} else {
			HBaseUtil.CreateTable_upload(DB, uploadList);
		}
	}

	public static void CreateTable_detail(String DB, String tableName) throws Exception {
		// TODO Auto-generated method stub
		if (Constant.DbConnection.containsKey("Db-Mysql") && Constant.DbConnection.get("Db-Mysql") != null) {
			MySQLUtil.CreateTable_detail(DB, tableName);
		} else {
			HBaseUtil.CreateTable_detail(DB, tableName);
		}
	}

}
